// API functions...
function canInspectSelection()
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return false; }

	var selNode = docDOM.getSelectedNode();
	if (!selNode) { return false; }

	var selAttr = selNode.getAttribute("Editor");
	if (selAttr)
	{
		var bCanInspect = (selAttr == "Webstyle2");
		if (bCanInspect)
		{
			selAttr = selNode.getAttribute("ModuleId");
			bCanInspect = (selAttr && (selAttr != ""));
		}

		return bCanInspect;
	}

	// This should check for the translated version now...
	var translatorClass = selNode.getAttribute("translatorClass");
	if (!translatorClass || (translatorClass != "WSDwExTrans")) { return false; }

	var lockType = selNode.getAttribute("type");
	if (!lockType || (lockType != "WSDwExTrans")) { return false; }

	return true;
}

// Actually do something in the Property Inspector...
function inspectSelection()
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return; }

	var selObj = docDOM.getSelectedNode();
	if (!selObj) { return; }

	var selHTML = selObj.innerHTML;

	// Find the image name...
	var imageSrc = selHTML.match(/img *src=\"([^\"]*)\"/i)[1];
	var imgSrc = imageSrc.replace(/\\/g, "/");
	var index = imgSrc.lastIndexOf("/");

	if (index != -1) { imgSrc = unescape(imgSrc.substr(index+1)); }
	var piObject = findObject("WSPI File");
	if (piObject  && imgSrc) { piObject.innerHTML = imgSrc.substr(0, 35); }

	// Find the project string within the moduleID...
	var projectName = unescape(selHTML.match(/moduleid=\"\'*([^\"]*) \(Project\)\\[^\"]*\"/i)[1]);
	piObject = findObject("WSPI Project");
	if (piObject && projectName) { piObject.innerHTML = projectName.substr(0, 35); }

	// Set the alignment button/indicator as appropriate...
	switch (dw.getDocumentDOM().getTextAlignment())
	{
		case 'left' :
			wsSetLeftAlign();
			break;

		case 'center' :
			wsSetCenterAlign();
			break;

		case 'right' :
			wsSetRightAlign();
			break;

		default :
			wsSetNoAlign();
			break;
	}

	// Set the 'Link' input field...
	piObject = findObject("WSPI Link Edit");
	if (piObject) { piObject.value = unescape(getNodeAnchorAttribute(selObj, "href")); }

	// Set the 'Alt' input field...
	piObject = findObject("WSPI Alt Edit");
	if (piObject) { piObject.value = getNodeAlt(selObj); }

	// Set the 'Target' input field...
	piObject = findObject("WSPI Target Edit");
	if (piObject) { piObject.value = getNodeAnchorAttribute(selObj, "target"); }

	// Find the image in the dom...
	if (!docDOM.images || (docDOM.images.length < 1)) { return; }
	var selDomImage = null;


	// We have to match the image name found earlier in the image list - this is not so easy as our NavBars have a <script><noscript> bit
	// and the image list just constructs a default <img src="xxx"> tag around the image specified in our <noscript>...
	var testString = "<img src=\"" + imageSrc + "\"";
	for (var nCounter=0; nCounter < docDOM.images.length; nCounter++)
	{
		if (testString.toLowerCase() == docDOM.images[nCounter].outerHTML.substr(0,testString.length).toLowerCase())
		{
			selDomImage = docDOM.images[nCounter];
			break;
		}
	}

	// Make some variables to hold the width and height data...
	var docWidth = selObj.getAttribute("width");
	var docHeight = selObj.getAttribute("height");
	var bmpWidth = 0;
	var bmpHeight = 0;

	// If we found the correct image in the DOM's image list, then proceed...
	if (selDomImage)
	{
		// Get the image source as recorded in the DOM - this should be the absolute path used to locate the image...
		var imageSource = selDomImage.src;
		if (imageSource && !(docWidth && docHeight))
		{
			// Convert it to an absolute path and remove web-specific mark-up so that the bitmap importer can't get confused!
			imageSource = dw.relativeToAbsoluteURL(getExportPath(), dw.getSiteRoot(), imageSource);
			imageSource = unescape(imageSource);
			imageSource = imageSource.replace(/file:\/\/\//gi, "");
			imageSource = imageSource.replace(/|/gi, ":");
			imageSource = imageSource.replace(/\//gi, "\\");

			// ***** TEMPORARY: The BmpImpr.dll doesn't work with PNGs!!! *****
			if (imageSource.substr(imageSource.length-4, 4).toLowerCase() != ".png")
			{
				// Call into our JS DLL and get Webstyle's bitmap importer to extract the image's dimensions...
				var result = WSDwExJs.GetImageDimensions(imageSource);
				bmpWidth = result[0];
				bmpHeight = result[1];
			}
		}
	}

	// If we didn't know both values in the document, then we need to scale the other value by the one of the original file
	if ((bmpWidth != 0) && (bmpHeight != 0))
	{
		if (!docWidth && docHeight) { docWidth = Math.floor((bmpWidth/bmpHeight) * docHeight); }
		if (!docHeight && docWidth) { docHeight = Math.floor((bmpHeight/bmpWidth) * docWidth); }
	}

	var imageWidth = "";
	var imageHeight = "";
	if (docWidth) { imageWidth = docWidth; } else if (bmpWidth != 0) { imageWidth = bmpWidth; }
	if (docHeight) { imageHeight = docHeight; } else if (bmpHeight != 0) { imageHeight = bmpHeight; }

	// Set the 'Width' field...
	piObject = findObject("WSPI Width");
	if (piObject) { piObject.innerHTML = imageWidth; }

	// Set the 'Height' field...
	piObject = findObject("WSPI Height");
	if (piObject) { piObject.innerHTML = imageHeight; }
}

// User has asked to insert a new object...
function objectTag()
{
	webstyleNew(-1);
	return("");
}

// The menu items for Button, Logo, etc pass us an argument, which we should then pass on to the webstyleNew() function...
function receiveArguments()
{
	if (arguments.length != 1) return;
	var graphicType = arguments[0];
	if (graphicType == 'U') { UpdateWebstyle(); return; }
	webstyleNew(graphicType);
}

// Turn the actual live HTML into something which can be displayed by both the DW editor and the browser. We save out the untranslated 'orig' to file...
function translateMarkup(docNameStr, siteRootStr, inStr)
{
//	Sample HTML generated by Webstyle2.1...
//<script webstyle2 src="C:\test\test.js">/* imgsrc="file:///C:\test\test.gif" moduleid="Default (Project)\test_off.xws"*/</script>
	var wsPattern = /(\<script +webstyle2 +src *= *\"([^\"]*)\"\>)\/\* +imgsrc *= *\"([^\"]*)\" +moduleid *= *\"[^\"]*\"\*\/(\<\/script\>)/gi;
	
	var outStr = inStr.replace(wsPattern,
		function (orig, scriptStart, scriptSrc, imgSrc, scriptEnd)
		{
			return "<MM:BeginLock translatorClass=\"WSDwExTrans\" type=\"WSDwExTrans\" orig=\"" + escape(orig) + "\">\n<script webstyle2 src=\"" + scriptSrc + "\"></script><noscript><br><img src=\"" + imgSrc + "\"><br></noscript>\n<MM:EndLock>";
		});

	return outStr;
}

// Function called by DW to establish if this translator can act on the current document...
function getTranslatorInfo()
{
	var returnArray = new Array(9);

	returnArray[0] = "WSDwExTrans";			// The translatorClass
	returnArray[1] = "Webstyle Translator";	// The title
	returnArray[2] = "2";								// The number of extensions
	returnArray[3] = "html";							// The second extension
	returnArray[4] = "htm";							// The third extension
	returnArray[5] = "1";								// The number of expressions
	returnArray[6] = "<script webstyle2 ";		// Expression for PI and insert
	returnArray[7] = "allFiles";						// Default translation on for all files
	returnArray[8] = "50";							// priority order to apply translator

	return returnArray;
}			

// API function - puts the 'Help' icon on our inspector and calls the correct help function...
function displayHelp()
{
	showHelp();
}




// Webstyle-specific functions...
// In the functions below, the webstyle js dll is executed and the return value ('result') is an array with the following components
//	result[0]	Bool		Success
//	result[1]	String	ModuleID
//	result[2]	String	LiveHTML
//	result[3]	String	PreviewHTML


// Edit the current selection with Webstyle
function webstyleEdit()
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return; }

	var selNode = docDOM.getSelectedNode();
	if (!selNode) { return; }

	var modID = selNode.innerHTML.match(/moduleid *= *(\"[^\"]*\")/i);
	if (!modID || !modID[1]) { return; }
	modID = modID[1];

	// Find the state of the objects and properties floaters - if they are visible we will need to hide them...
	var bShowObjectsFloater = dreamweaver.getFloaterVisibility("objects");
	if (bShowObjectsFloater) { dreamweaver.setFloaterVisibility("objects", false); }

	var bShowPropertiesFloater = dreamweaver.getFloaterVisibility("properties");
	if (bShowPropertiesFloater) { dreamweaver.setFloaterVisibility("properties", false); }

	// Launch Webstyle to edit the image...
	var result = WSDwExJs.Edit(modID, "", -1, getExportPath());
	if (result[0] != true)
	{
		if (bShowObjectsFloater) { dreamweaver.setFloaterVisibility("objects", true); }
		if (bShowPropertiesFloater) { dreamweaver.setFloaterVisibility("properties", true); }
		return;
	}

	// Remove the single and double quotes...
	modID = result[1].replace(/\'/g, "");
	modID = modID.replace(/\"/g, "");

	// If we are replacing a non-translated object with another, then do the special case...
	if ((selNode.outerHTML.search(/< *script/gi) == -1) && (result[2].search(/< *script/gi) == -1))
	{
		var imgSrc = result[2].match(/< *img +.*\bsrc *= *\"([^\"]*)\"/i)[1];
		var selectedNode = selNode.outerHTML;
		selectedNode = replaceModuleID(modID, selectedNode);
		selectedNode = replaceImgSrc(imgSrc, selectedNode);
		selectedNode = removeWidthAndHeight(selectedNode);
		if (selectedNode && (selectedNode != "")) { selNode.outerHTML = selectedNode; }
	}
	else
	{
		// Get the currently selected node and update the html...
		var offsets = docDOM.getSelection();
		var docSrc = docDOM.documentElement.outerHTML;
		var beforeSelStr = docSrc.substring(0, offsets[0]);
		var afterSelStr = docSrc.substring(offsets[1]);

		// Assemble the new contents of the document.
		docSrc = beforeSelStr + modifyWebstyleHTML(result[2], modID) + afterSelStr;
		docDOM.documentElement.outerHTML = docSrc;
		docDOM.setSelection(offsets[0], offsets[1]);
	}

	// Force translator to execute...
	forceTranslate();

	if (bShowObjectsFloater) { dreamweaver.setFloaterVisibility("objects", true); }
	if (bShowPropertiesFloater) { dreamweaver.setFloaterVisibility("properties", true); }
}

// Replace the module ID parameter with a new one!
function replaceModuleID(modID, strHTML)
{
	if (!modID || !strHTML) { return ""; }
	return strHTML.replace(/(< *img +.*\bmoduleid *= *\")[^\"]*(\")/gi, function (orig, beforeModID, afterModID) { return beforeModID + modID + afterModID; } );
}

// Replace the image source parameter...
function replaceImgSrc(imgSrc, strHTML)
{
	if (!imgSrc || !strHTML) { return ""; }
	return strHTML.replace(/(< *img +.*\bsrc *= *\")[^\"]*(\")/gi, function (orig, beforeImage, afterImage) { return beforeImage + imgSrc + afterImage; } );
}

// Remove the width and height attributes...
function removeWidthAndHeight(strHTML)
{
	if (!strHTML) { return ""; }

	// Remove the width and height...
	strHTML = strHTML.replace(/(< *img +.*)\bwidth *= *\"[^\"]*\"/gi, function (orig, beforeWidth) { return beforeWidth; } );
	strHTML = strHTML.replace(/(< *img +.*)\bheight *= *\"[^\"]*\"/gi, function (orig, beforeHeight) { return beforeHeight; } );
	return strHTML;
}

// Update Webstyle
function UpdateWebstyle()
{
	// Launch Webstyle in Update mode...
	var result = WSDwExJs.Update();
}

// Create a new object with Webstyle
function webstyleNew(graphicType)
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return; }

	// Find the state of the objects and properties floaters - if they are visible we will need to hide them...
	var bShowObjectsFloater = dreamweaver.getFloaterVisibility("objects");
	if (bShowObjectsFloater) { dreamweaver.setFloaterVisibility("objects", false); }

	var bShowPropertiesFloater = dreamweaver.getFloaterVisibility("properties");
	if (bShowPropertiesFloater) { dreamweaver.setFloaterVisibility("properties", false); }

	// Launch Webstyle to produce a new graphic with the current options...
	var result = WSDwExJs.Edit(getExportPath(), getBackgroundColour(), graphicType, getExportPath());
	if (result[0] != true)
	{
		if (bShowObjectsFloater) { dreamweaver.setFloaterVisibility("objects", true); }
		if (bShowPropertiesFloater) { dreamweaver.setFloaterVisibility("properties", true); }
		return;
	}

	// Remove the single and double quotes...
	var modID = result[1].replace(/\'/g, "");
	modID = modID.replace(/\"/g, "");

	// Insert the HTML Into the document...
	docDOM.insertHTML(modifyWebstyleHTML(result[2], modID), false);

	// Force translator to execute...
	forceTranslate();

	if (bShowObjectsFloater) { dreamweaver.setFloaterVisibility("objects", true); }
	if (bShowPropertiesFloater) { dreamweaver.setFloaterVisibility("properties", true); }
}

// Find the current document's export path - Webstyle will use this as the default directory to save images to...
function getExportPath()
{
	var path = dreamweaver.getDocumentPath("document");

	var index = path.lastIndexOf('/');
	if (index != -1) { path = path.substring(0, index); }

	return path;
}

// Get the current document's background colour...
function getBackgroundColour()
{
	var docDOM = dreamweaver.getDocumentDOM("document");
	if (!docDOM) { return "NoColor"; }

	var bgCol = docDOM.body.bgcolor;
	if (!bgCol) { bgCol = "NoColor"; }
	return bgCol;
}

// Get the dll to show the Webstyle help on the appropriate page...
function showHelp()
{
	WSDwExJs.ShowHelp();
}

// Get the dll to show the information for itself (file version etc)...
function moduleInfo()
{
	WSDwExJs.ModuleInfo();
}

// Function to force a translation - DW3 doesn't appear to run translators as often as DW4...
function forceTranslate()
{
	dreamweaver.getDocumentDOM().documentElement.outerHTML = translateMarkup("", "", dreamweaver.getDocumentDOM().documentElement.outerHTML);
}

// Change Webstyle produced HTML into something that DW can successfully display...
function modifyWebstyleHTML(html, moduleid)
{
	//	Sample NavBar HTML generated by Webstyle2.1... We need to convert this into something Dreaweaver will display!
	//	<script webstyle2 src="C:\WebStyle2.x\Export\testnav.js"></script><noscript><img src="../../../WebStyle2.x/Export/testnav.gif" editor="Webstyle2"></noscript>
	var wsPattern = /(\<script +webstyle2 +src=\"[^\"]*\"\>)(\<\/script\>)\s*\<noscript\>\<img +src=\"([^\"]*)\" +editor=\"Webstyle2\"\>\<\/noscript\>/gi;
	var dwString = html.replace(wsPattern, function (orig, scriptStart, scriptEnd, imgSrc) { return scriptStart + "\/\* imgsrc=\"" + escape(imgSrc) + "\" moduleid=\"" + escape(moduleid) + "\"\*\/" + scriptEnd; });
	dwString = dwString.replace(/img +src=\"[^\"]*\" +editor=\"Webstyle2\"/i, function(orig) { return orig + " moduleid=\"" + moduleid + "\""; });
	return dwString;
}


// Property Inspector Alignment Button/Indicator Functions...
function wsPerformAlignment(desiredAlignment)
{
	var bVersionThree = false;
	if (dw.appVersion)
	{
		var re = /^\d+/;
		var appversion = dw.appVersion.match(re);
		if (appversion && (appversion == 3)) { bVersionThree = true; }
	}

	// If we're running on Dreamweaver3, we can set the alignment anytime, if we're in 4 then we can only set it when the
	// focus is on the main preview editor - the 'document'
	if (bVersionThree || (dw.getFocus(false) == 'document'))
	{
		// Update the alignment as requested...
		dw.getDocumentDOM().setTextAlignment(desiredAlignment);

		// Update the property inspector to reflect this...
		switch (desiredAlignment)
		{
			case 'left' :
				wsSetLeftAlign();
				break;

			case 'center' :
				wsSetCenterAlign();
				break;

			case 'right' :
				wsSetRightAlign();
				break;

			default :
				wsSetNoAlign();
				break;
		}
	}
	else
	{
		alert("Object alignment cannot be adjusted at this time.\nPlease select the object in the document view.");
	}
}


function wsSetNoAlign()
{
	setAlignObjectSelected("WSPI Align Left", false);
	setAlignObjectSelected("WSPI Align Center", false);
	setAlignObjectSelected("WSPI Align Right", false);
}

function wsSetLeftAlign()
{
	setAlignObjectSelected("WSPI Align Left", true);
	setAlignObjectSelected("WSPI Align Center", false);
	setAlignObjectSelected("WSPI Align Right", false);
}

function wsSetCenterAlign()
{
	setAlignObjectSelected("WSPI Align Left", false);
	setAlignObjectSelected("WSPI Align Center", true);
	setAlignObjectSelected("WSPI Align Right", false);
}

function wsSetRightAlign()
{
	setAlignObjectSelected("WSPI Align Left", false);
	setAlignObjectSelected("WSPI Align Center", false);
	setAlignObjectSelected("WSPI Align Right", true);
}

function isAlignObjectSelected(alignObject)
{
	var imgSrc = alignObject.innerHTML.match(/img *src=\"([^\"]*)\"/i)[1];
	return (-1 != imgSrc.lastIndexOf("_sel.gif"));
}

function setAlignObjectSelected(alignObjectId, bDesiredSelected)
{
	var alignObject = findObject(alignObjectId);
	if (!alignObject) { return; }

	var bSelected = isAlignObjectSelected(alignObject);
	if (bDesiredSelected && !bSelected) { alignObject.innerHTML = alignObject.innerHTML.replace(/\.gif\"/i, "_sel.gif\""); }
	if (!bDesiredSelected && bSelected) { alignObject.innerHTML = alignObject.innerHTML.replace(/_sel\.gif\"/i, ".gif\""); }
}

// Property Inspector Link/Target Edit Field function...
function webstyleAnchorAttributeEdit(anchorAttribute, piObject, bEscape)
{
	var docDOM = dw.getDocumentDOM("document");
	if (!docDOM || !piObject) { return; }

	var selNode = docDOM.getSelectedNode();
	if (!selNode) { return; }

	var newValue = findObject(piObject).value;
	if (bEscape) { newValue = escape(newValue); }
	if (!replaceNodeAnchorAttribute(selNode, anchorAttribute, newValue) && (newValue != ""))
	{
		// Then this node doesn't have a parent which is an anchor tag, so wrap it in one!...
		docDOM.wrapTag("<a "+anchorAttribute+"=\"" + newValue + "\">");
	}
}

// Property Inspector Alt Edit Field functions...
function webstyleAltEdit()
{
	var docDOM = dw.getDocumentDOM("document");
	if (!docDOM) { return; }

	var selNode = docDOM.getSelectedNode();
	if (!selNode) { return; }

	var piObject = findObject("WSPI Alt Edit");
	if (!piObject) { return; }

	var newValue = piObject.value;
	if (newValue != getNodeAlt(selNode)) { selNode.setAttribute("alt", newValue); }
}

function getNodeAlt(currentNode)
{
	if (!currentNode) { return ""; }

	var currentAlt = currentNode.getAttribute("alt");
	if (!currentAlt) { currentAlt = ""; }
	return currentAlt;
}

// Generic functions to recursively search up the tree from the specified node looking for an anchor tag which is the parent of the current node
// Once found, the specified attribute is modified to the new value.
function replaceNodeAnchorAttribute(currentNode, anchorAttribute, newValue)
{
	if (!currentNode) { return false; }

	var currentTag = currentNode.tagName;
	if (!currentTag) { return false; }

	if (currentTag == "A")
	{
		if (currentNode.getAttribute(anchorAttribute) != newValue) { currentNode.setAttribute(anchorAttribute, newValue); }
		return true;
	}
	else
	{
		return replaceNodeAnchorAttribute(currentNode.parentNode, anchorAttribute, newValue);
	}
}

function getNodeAnchorAttribute(currentNode, anchorAttribute)
{
	if (!currentNode) { return ""; }

	var currentTag = currentNode.tagName;
	if (!currentTag) { return ""; }

	if (currentTag == "A")
	{
		var attributeValue = currentNode.getAttribute(anchorAttribute);
		if (!attributeValue || (attributeValue == "undefined")) { attributeValue = ""; }
		return attributeValue;
	}
	else
	{
		return getNodeAnchorAttribute(currentNode.parentNode, anchorAttribute);
	}
}

function removeXolDummyWSMenu()
{
	WSDwExJs.RemoveDreamweaverXolDummyWSMenu(dreamweaver.getConfigurationPath());
}